import { Module, Store as VuexStore } from 'vuex';
import { ModuleNamespaceMap, Config, PayloadWithType, Result, When } from './types';
declare class Store implements VuexStore<any> {
    state: any;
    getters: any;
    _modulesNamespaceMap: ModuleNamespaceMap;
    $$modules: Module<any, any>;
    $$when: When[];
    $$assertions: When[];
    constructor(config: Config);
    readonly $$isStore: boolean;
    registerModule(path: string, config: Config): void;
    registerModule(path: string[], config: Config): void;
    unregisterModule(path: string): void;
    unregisterModule(path: string[]): void;
    replaceState(state: object): void;
    watch(fn: (state: any, getters: any) => any, cb: (value: any, oldValue: any) => void, options?: any): () => void;
    subscribe(handler: (mutation: any, state: any) => void): () => void;
    subscribeAction(handler: (action: any, state: any) => void): () => void;
    hotUpdate(options: any): void;
    commit(name: string): any;
    commit(name: string, payload: any): any;
    commit(payload: PayloadWithType): any;
    dispatch(name: string): Promise<any>;
    dispatch(name: string, payload: any): Promise<any>;
    dispatch(payload: PayloadWithType): Promise<any>;
    when(method?: string | RegExp, name?: string | RegExp): Result;
    otherwise(): Result;
    expect(): Result;
    expect(count: number): Result;
    expect(method: string | RegExp): Result;
    expect(method: string | RegExp, count: number): Result;
    expect(method: string | RegExp, name: string | RegExp): Result;
    expect(method: string | RegExp, name: string | RegExp, count: number): Result;
    assert(): void;
    $$doWhen(method: string, name: string, ...args: any[]): any;
}
export default Store;
