import Vue from 'vue';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

// eslint-disable-next-line max-len
var isObject = function isObject(obj) {
  return Object.prototype.toString.call(obj) === '[object Object]';
};
var last = function last(arr) {
  return arr[arr.length - 1];
};
var normalizeModule = function normalizeModule(config) {
  var result = {
    namespaced: false,
    state: {},
    getters: {},
    mutations: {},
    actions: {},
    modules: {}
  };

  if (!config.state && !config.getters && !config.mutations && !config.actions && !config.modules && config.namespaced == null) {
    result.namespaced = true;
    Object.keys(config).forEach(function (key) {
      // @ts-ignore
      var state = config[key];

      if (isObject(state)) {
        result.modules[key] = state;
      } else {
        result.state[key] = state;
      }
    });
  } else {
    Object.assign(result, config);
  }

  Object.keys(result.modules).forEach(function (key) {
    result.modules[key] = normalizeModule(result.modules[key]);
  });
  return result;
};
var normalizePayload = function normalizePayload(name, payload) {
  if (_typeof(name) === 'object') {
    return {
      name: name.type,
      payload: name
    };
  }

  return {
    name: name,
    payload: payload
  };
};
var createModuleNamespace = function createModuleNamespace() {
  return {
    context: {
      getters: {},
      state: {},
      commit: {},
      dispatch: {}
    }
  };
};

var reactify = function reactify(obj) {
  var reactive = new Vue({
    data: {
      data: obj
    }
  });
  return reactive.data;
};

var Store =
/*#__PURE__*/
function () {
  function Store(config) {
    _classCallCheck(this, Store);

    _defineProperty(this, "state", reactify({}));

    _defineProperty(this, "getters", {});

    _defineProperty(this, "_modulesNamespaceMap", {});

    _defineProperty(this, "$$modules", void 0);

    _defineProperty(this, "$$when", []);

    _defineProperty(this, "$$assertions", []);

    this.registerModule([], config);
  }

  _createClass(Store, [{
    key: "registerModule",
    value: function registerModule(p, config) {
      var _this = this;

      var path;

      if (typeof p === 'string') {
        path = p.split('/');
      } else {
        path = p;
      } // module


      var moduleName = last(path);
      var pathToModule = path.slice(0, -1);
      var parentModule = pathToModule.reduce(function (module, key) {
        if (module.modules[key] == null) {
          // eslint-disable-next-line no-param-reassign
          module.modules[key] = normalizeModule({});
        }

        return module.modules[key];
      }, this.$$modules);
      var module;
      var m;
      var state;

      if (moduleName != null) {
        module = parentModule.modules[moduleName] = normalizeModule(config);
        var namespaceKey = (module.namespaced ? path : []).join('/') + '/'; // eslint-disable-next-line max-len

        m = this._modulesNamespaceMap[namespaceKey] = this._modulesNamespaceMap[namespaceKey] || createModuleNamespace();
        var parentState = pathToModule.reduce(function (state, key) {
          if (state[key] == null) {
            Vue.set(state, key, {});
          }

          return state[key];
        }, this.state);
        Vue.set(parentState, moduleName, module.state);
        state = parentState[moduleName];
        m.context.state = state;
      } else {
        module = this.$$modules = normalizeModule(config);
        m = this._modulesNamespaceMap['/'] = createModuleNamespace();
        state = this.state = reactify(module.state);
        m.context.state = state;
      }

      var localGetters = {};
      Object.keys(module.getters).forEach(function (key) {
        var getter = module.getters[key];
        var prefix = module.namespaced ? path : [];
        var getterKey = prefix.concat(key).join('/');
        var property = {
          enumerable: true,
          get: function get() {
            return getter(state, localGetters, _this.state, _this.getters);
          }
        };
        Object.defineProperty(localGetters, key, property);
        Object.defineProperty(m.context.getters, key, property);
        Object.defineProperty(_this.getters, getterKey, property);
      });
      Object.keys(module.mutations).forEach(function (key) {
        var mutation = module.mutations[key];
        var getterKey = path.concat(key).join('/');

        if (typeof mutation === 'function') {
          var fn = mutation;

          mutation = function mutation(state, payload) {
            return fn(m.context.state, payload);
          };

          _this.when('commit', getterKey).call(mutation);

          if (!module.namespaced) {
            _this.when('commit', key).call(mutation);
          }
        } else {
          _this.when('commit', getterKey).return(mutation);

          if (!module.namespaced) {
            _this.when('commit', key).return(mutation);
          }
        }

        m.context.commit = function (name, payload) {
          return _this.commit(path.concat(name).join('/'), payload);
        };
      });
      Object.keys(module.actions).forEach(function (key) {
        var action = module.actions[key];

        if (typeof action === 'function') {
          var fn = action;

          action = function action(context, payload) {
            return fn.call(_this, _objectSpread({}, context, {
              state: m.context.state,
              getters: m.context.getters
            }), payload);
          };

          _this.when('dispatch', path.concat(key).join('/')).call(action);

          if (!module.namespaced) {
            _this.when('dispatch', key).call(action);
          }
        } else {
          _this.when('dispatch', path.concat(key).join('/')).return(action);

          if (!module.namespaced) {
            _this.when('dispatch', key).return(action);
          }
        }

        m.context.dispatch = function (name, payload) {
          return _this.dispatch(path.concat(name).join('/'), payload);
        };
      });
      Object.keys(module.modules).forEach(function (key) {
        _this.registerModule(path.concat(key), module.modules[key]);
      });
    }
  }, {
    key: "unregisterModule",
    value: function unregisterModule(p) {
      var path;

      if (typeof p === 'string') {
        path = p.split('/');
      } else {
        path = p;
      }

      var name = last(path);
      path = path.slice(0, -1);
      var moduleKey = path.concat('').join('/');
      var state = this.state;
      path.forEach(function (key) {
        state = state && state[key];
      });

      if (this._modulesNamespaceMap[moduleKey]) {
        delete this._modulesNamespaceMap[moduleKey];
      }

      if (state && state[name]) {
        Vue.delete(state, name);
      }
    }
  }, {
    key: "replaceState",
    value: function replaceState(state) {
      this.state = reactify(state);
    }
    /* eslint-disable no-unused-vars */

    /* eslint-disable @typescript-eslint/no-unused-vars */

  }, {
    key: "watch",
    value: function watch(fn, cb, options) {
      return function () {};
    }
  }, {
    key: "subscribe",
    value: function subscribe(handler) {
      return function () {};
    }
  }, {
    key: "subscribeAction",
    value: function subscribeAction(handler) {
      return function () {};
    }
  }, {
    key: "hotUpdate",
    value: function hotUpdate(options) {}
    /* eslint-enable no-unused-vars */

    /* eslint-enable @typescript-eslint/no-unused-vars */

  }, {
    key: "commit",
    value: function commit(n, p) {
      var _normalizePayload = normalizePayload(n, p),
          name = _normalizePayload.name,
          payload = _normalizePayload.payload;

      var pathToCommit = name.split('/').slice(0, -1);
      var state = pathToCommit.reduce(function (last, current) {
        return last && last[current];
      }, this.state);
      return this.$$doWhen('commit', name, state, payload);
    }
  }, {
    key: "dispatch",
    value: function dispatch(n, p) {
      var _this2 = this;

      var _normalizePayload2 = normalizePayload(n, p),
          name = _normalizePayload2.name,
          payload = _normalizePayload2.payload;

      var pathToAction = name.split('/').slice(0, -1);
      var state = pathToAction.reduce(function (last, current) {
        return last && last[current];
      }, this.state);
      var rootState = this.state;

      var commit = function commit(n, p) {
        var _normalizePayload3 = normalizePayload(n, p),
            name = _normalizePayload3.name,
            payload = _normalizePayload3.payload;

        var commitName = pathToAction.concat(name).join('/');
        return _this2.commit(commitName, payload);
      };

      var dispatch = function dispatch(n, p) {
        var _normalizePayload4 = normalizePayload(n, p),
            name = _normalizePayload4.name,
            payload = _normalizePayload4.payload;

        var dispatchName = pathToAction.concat(name).join('/');
        return _this2.dispatch(dispatchName, payload);
      };

      var getters = this.getters;
      var context = {
        state: state,
        rootState: rootState,
        commit: commit,
        dispatch: dispatch,
        getters: getters
      };

      try {
        return Promise.resolve(this.$$doWhen('dispatch', name, context, payload));
      } catch (err) {
        return Promise.reject(err);
      }
    }
  }, {
    key: "when",
    value: function when(method, name) {
      var matchAny = /.*/;
      /* eslint-disable no-param-reassign */

      if (method === undefined && name === undefined) {
        method = name = matchAny;
      } else if (method === undefined) {
        method = matchAny;
      } else if (name === undefined) {
        name = method;
        method = matchAny;
      }
      /* eslint-enable no-param-reassign */


      if (typeof method === 'string') {
        // eslint-disable-next-line no-param-reassign
        method = method.toLowerCase();
      }

      var when = {
        method: method,
        name: name,
        count: 0,
        otherwise: false,
        callback: function callback(context, payload) {
          return payload;
        }
      };
      this.$$when.push(when);
      var result = {
        return: function _return(value) {
          when.callback = function () {
            return value;
          };

          return this;
        },
        call: function call(cb) {
          when.callback = cb;
          return this;
        },
        stop: function stop() {
          when.callback = function () {
            return new Promise(function () {});
          };

          return this;
        },
        throw: function _throw(value) {
          return this.reject(value);
        },
        reject: function reject(value) {
          when.callback = function () {
            throw value || new Error();
          };

          return this;
        }
      };
      return result;
    }
  }, {
    key: "otherwise",
    value: function otherwise() {
      this.$$when.reverse();
      var result = this.when();
      this.$$when.reverse();
      this.$$when[0].otherwise = true;
      return result;
    }
  }, {
    key: "expect",
    value: function expect(m, n, c) {
      var method;
      var name;
      var count;

      if (typeof m === 'number') {
        method = undefined;
        name = undefined;
        count = m;
      } else if (typeof n === 'number') {
        method = m;
        name = undefined;
        count = n;
      } else {
        method = m;
        name = n;
        count = c;
      }

      var result = this.when(method, name);
      var when = last(this.$$when);
      when.expected = count;
      this.$$assertions.push(when);
      return result;
    }
  }, {
    key: "assert",
    value: function assert() {
      var assertions = this.$$assertions.splice(0);
      assertions.forEach(function (assertion) {
        var a = JSON.stringify({
          method: assertion.method,
          name: assertion.name
        });

        if (typeof assertion.expected === 'number') {
          if (assertion.expected !== assertion.count) {
            throw new Error("Expected ".concat(a, " to have been called ").concat(assertion.expected, " times but was called ").concat(assertion.count, " times"));
          }
        } else if (assertion.count < 1) {
          throw new Error("Expected a call for ".concat(a));
        }
      });
    }
  }, {
    key: "$$doWhen",
    value: function $$doWhen(method, name) {
      var _this3 = this;

      for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }

      // eslint-disable-next-line no-param-reassign
      method = method.toLowerCase();
      var lastArg = last(args);
      var requests = this.$$when.slice().reverse().filter(function (when) {
        if (when.method instanceof RegExp) {
          if (!when.method.test(method)) {
            return false;
          }
        } else if (when.method !== method) {
          return false;
        }

        if (when.name instanceof RegExp) {
          if (!when.name.test(name)) {
            return false;
          }
        } else if (when.name !== name) {
          return false;
        }

        return true;
      }).filter(function (when, i, arr) {
        if (i === 0) {
          return true;
        } else if (arr.length > 1 && when.otherwise) {
          return false;
        } else {
          return true;
        }
      });
      return requests.reduce(function (x, when) {
        // eslint-disable-next-line no-param-reassign
        when.count++;

        if (when.callback) {
          return when.callback.apply(_this3, args);
        } else {
          return x;
        }
      }, lastArg);
    }
  }, {
    key: "$$isStore",
    get: function get() {
      return true;
    }
  }]);

  return Store;
}();

var index = (function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return new Store(config);
});

export default index;
//# sourceMappingURL=mock-vuex.es.js.map
